unit bina;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, VOICERLIB200Lib_TLB, StdCtrls, ExtCtrls, ShellApi;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    lblNumPortas: TLabel;
    Label3: TLabel;
    txtPorta: TEdit;
    LeiaMe: TButton;
    Panel2: TPanel;
    btnInicia: TButton;
    btnFinaliza: TButton;
    optPCI1: TRadioButton;
    optPCI4: TRadioButton;
    Label4: TLabel;
    vlib: TVoicerLib200;
    GroupBox1: TGroupBox;
    lbltwist1: TLabel;
    txttwist1: TEdit;
    lbltwist2: TLabel;
    txttwist2: TEdit;
    optdtmf: TRadioButton;
    optmfp: TRadioButton;
    btnAplica: TButton;
    Label1: TLabel;
    memLog: TMemo;
    btnExibe: TButton;
    btnLimpaLog: TButton;
    procedure FormCreate(Sender: TObject);
    procedure vlibCallerID(ASender: TObject; Port: Smallint;
      const Number: WideString);
    procedure btnAplicaClick(Sender: TObject);
    procedure btnIniciaClick(Sender: TObject);
    procedure vlibRingDetected(ASender: TObject; Port: Smallint);
    procedure btnExibeClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure btnLimpaLogClick(Sender: TObject);
    procedure GeraLog(nPorta: Integer; sMsg: String);
    procedure btnFinalizaClick(Sender: TObject);
    procedure LeiaMeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
    nFormato: Integer;
    Form1: TForm1;
    sBina : String;
implementation

{$R *.dfm}


procedure TForm1.GeraLog(nPorta: Integer; sMsg: String);
begin
  try
    memLog.Lines.Add('<' + TimeToStr(Time) + '>' + IntToStr(nPorta) + ' -> ' + sMsg);
  except;
    Application.MessageBox('GeraLog', 'Except', mb_OK);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Define os valores de twist default;
  txttwist1.Text := '10';
  txttwist2.Text := '0';
  btnFinaliza.Enabled := False;
  btnAplica.Enabled := False;
  btnExibe.Enabled := False;
  txtPorta.Text := '1';
end;

procedure TForm1.vlibCallerID(ASender: TObject; Port: Smallint;
  const Number: WideString);
begin
  //Exibe o nmero identificado pelo Bina.
  memLog.Lines.Add('Nmero Identificado: ' + Number);
  sBina := Number;
end;

procedure TForm1.btnAplicaClick(Sender: TObject);
var
  nRet,nRet1 : Integer;
begin
  //Seta os valores de twist ajustados no programa
  vlib.SetDTMFTwist(strtoint(txttwist1.Text),strtoint(txttwist2.Text));
  GeraLog(StrToInt(txtPorta.Text), 'TWIST 1 : ' + txttwist1.Text + ' TWIST 2 : ' + txttwist2.Text);

  // Verifica qual foi a opo escolhida
  if optdtmf.Checked then
    nFormato:=wtDTMF
  else
    nFormato:=wtMFP;

  //Configura e Inicializa as funes de Idle para todos os canais da placa.
  nRet := vlib.IdleSettings(StrToInt(txtPorta.Text),True,2,1000, True, False, nFormato, 5000,20, '@');
  if nRet <> 0 then
    GeraLog(StrToInt(txtPorta.text), 'Erro ao setar propriedades -IdleSettings')
  else
    GeraLog(StrToInt(txtPorta.text), 'Propriedades setadas com sucesso -IdleSettings ' + IntToStr(nFormato));

  nRet1 := vlib.IdleStart(StrToInt(txtPorta.Text));
  //Testa se iniciou corretamente a monitorao
  if nRet1 = 99 then
    GeraLog(StrToInt(txtPorta.text), 'Erro ao iniciar a monitorao - ret=' + inttostr(nret))
  else
    GeraLog(StrToInt(txtPorta.text), 'Monitorao iniciada com sucesso');
end;

procedure TForm1.btnIniciaClick(Sender: TObject);
var
  nRet : Integer;
begin
  if optPCI1.Checked then
    //Placa PCI 1 canal
    vlib.CardType := ctVPPCI
  else
    //Placa PCI 4 canais
    vlib.CardType := ctVBPCI;
  //Inicializa a VoicerLib
  nRet := vlib.StartVoicerLib;

  //Testa o retorno do StartVoicerLib
  if nRet <> 99 then
    GeraLog(StrToInt(txtPorta.Text),'Erro ao iniciar a VoicerLib. Retorno: '+ IntToStr(nRet))
  else
  begin
    if optPCI1.Checked then
    begin
      txtPorta.Text := '1' ;
      txtPorta.Enabled := False;
    end;
    GeraLog(StrToInt(txtPorta.Text),'VoicerLib Iniciada com sucesso...');
    btnFinaliza.Enabled := true;
    btnInicia.Enabled := False;
    btnAplica.Enabled := True;
    btnExibe.Enabled := True;
  end;

  // Apresenta na tela o nmero de portas disponveis
  lblNumPortas.Caption := IntToStr(vlib.PortsCount);

  //Define os valores de twist default;
  txtTwist1.Text := '10';
  txtTwist2.Text := '0';
end;

procedure TForm1.vlibRingDetected(ASender: TObject; Port: Smallint);
begin
  GeraLog(StrToInt(txtPorta.Text),'Ring.....');
end;

procedure TForm1.btnExibeClick(Sender: TObject);
var
  nNumero: WideString;
begin
  // Exibe os nmeros identificados antes e depois do atendimento.
  nNumero:=vlib.ReadDigits(StrToInt(txtPorta.Text));
  memLog.Lines.Add('Nmero: ' +  nNumero);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: Integer;
begin
  for i := 1 to vlib.PortsCount do
    vlib.HangUp(i);
  vlib.ShutdownVoicerLib;
end;

procedure TForm1.btnLimpaLogClick(Sender: TObject);
begin
  MemLog.Clear;
end;

procedure TForm1.btnFinalizaClick(Sender: TObject);
var
  nRet : Integer;
begin

  //Interrompe a funcao de Idle
  Vlib.IdleAbort(StrtoInt(txtPorta.Text));
  GeraLog(StrtoInt(txtPorta.Text),'Finalizou IdleAbort...');

  //Finaliza a VoicerLib
  nRet := VLib.ShutdownVoicerLib;
  //Testa se desligou corretamente
  if nRet = 99 then
  begin
    if optPCI1.Checked then
      txtPorta.Enabled := true;
      
    GeraLog(StrToInt(txtPorta.text), 'Placa finalizada com sucesso');
    btnFinaliza.Enabled := False;
    btnInicia.Enabled := True;
  end                                                                                                               
  else
    Application.MessageBox('Erro na finalizao. Recomenda-se reiniciar o micro.', 'Exemplo de Bina - Erro', MB_OK,);
end;

procedure TForm1.LeiaMeClick(Sender: TObject);
var
  L : String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt' ;
  ShellExecute(0, nil ,PChar(L), nil,nil,SW_NORMAL);
end;

end.
